#include <stdio.h>
#include <math.h>
#include <bits/stdc++.h>
#include <string>
#define ll long long

using namespace std;

void unosN(vector<ll> &d,vector<ll> &p,ll N)
{
	for(int i=0;i<N;i++)
	{
		cin >> d[i] >> p[i];
	}
}

void unosQ(vector<ll> &k,vector<ll> &x,ll Q)
{
	for(int j=0;j<Q;j++)
	{
		cin >> k[j];
		x[j]=0;
	}
}

void plazma(vector<ll> &d,vector<ll> &p,vector<ll> &k,vector<ll> &x,ll N,ll Q)
{
	ll dan,kolicina;
	
	for(int i=0;i<N;i++)
	{
		
		
		for(int j=0;j<Q;j++)
		{
			dan = d[i];
			kolicina = p[i];
			
			while(k[j]>=dan && kolicina>0)
			{
				x[j]++;
				dan++;
				kolicina--;
			}
		}
	}
	
	for(int j=0;j<Q;j++)
	{
		cout << x[j] << endl;
	}
}

main()
{
	ll N,Q;
	
	cin >> N >> Q;
	
	vector<ll> d(N);
	vector<ll> p(N);
	vector<ll> k(Q);
	vector<ll> x(Q);
	
	unosN(d,p,N);
	unosQ(k,x,Q);
	plazma(d,p,k,x,N,Q);
}